StatsWindow = class(Turbine.UI.Window);
 
alphabetical_desc = 0;
alphabetical_asc = 1;
kills_desc = 2;
kills_asc = 3;

function StatsWindow:Constructor()

  local width = 250;
  local height = 450;
  local x = Turbine.UI.Display:GetWidth()/2 - width/2;
  local y = Turbine.UI.Display:GetHeight()/2 - height/2;

  Turbine.UI.Lotro.Window.Constructor(self);
  
  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetZOrder(1);
  self:SetText(L.Statistics);
  self:SetWantsKeyEvents(true);
  
  ---------- Stats Panel -------------
  self.stats_panel = Turbine.UI.Label();
  self.stats_panel:SetParent(self);
  self.stats_panel:SetSize(self:GetWidth() - 50,self:GetHeight() - 60);
  self.stats_panel:SetPosition(self:GetWidth() / 2 - self.stats_panel:GetWidth() / 2,40);
  self.stats_panel:SetVisible(true);
  self.stats_panel:SetMouseVisible(false);
  
  self.rank = Turbine.UI.Label();
  self.rank:SetParent(self.stats_panel);
  self.rank:SetSize(self.stats_panel:GetWidth(),15);
	self.rank:SetPosition(0,0);
  self.rank:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.rank:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.commendations = Turbine.UI.Label();
  self.commendations:SetParent(self.stats_panel);
  self.commendations:SetSize(self.stats_panel:GetWidth(),15);
	self.commendations:SetPosition(0,15);
  self.commendations:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.commendations:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  ---------- Points -------------
  self.points = Turbine.UI.Label();
  self.points:SetParent(self.stats_panel);
  self.points:SetSize(self.stats_panel:GetWidth(),20);
	self.points:SetPosition(0,40);
  self.points:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
  self.points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.points:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.points:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.points:SetText(L.InfamyRenown);

  self.points_total = Turbine.UI.Label();
  self.points_total:SetParent(self.stats_panel);
  self.points_total:SetSize(self.stats_panel:GetWidth(),15);
	self.points_total:SetPosition(0,60);
  self.points_total:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_total:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  self.points_to_rankup = Turbine.UI.Label();
  self.points_to_rankup:SetParent(self.stats_panel);
  self.points_to_rankup:SetSize(self.stats_panel:GetWidth(),15);
	self.points_to_rankup:SetPosition(0,75);
  self.points_to_rankup:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_to_rankup:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.points_this_day = Turbine.UI.Label();
  self.points_this_day:SetParent(self.stats_panel);
  self.points_this_day:SetSize(self.stats_panel:GetWidth(),15);
	self.points_this_day:SetPosition(0,90);
  self.points_this_day:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_this_day:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.points_last_24h = Turbine.UI.Label();
  self.points_last_24h:SetParent(self.stats_panel);
  self.points_last_24h:SetSize(self.stats_panel:GetWidth(),15);
	self.points_last_24h:SetPosition(0,105);
  self.points_last_24h:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_last_24h:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.points_last_hour = Turbine.UI.Label();
  self.points_last_hour:SetParent(self.stats_panel);
  self.points_last_hour:SetSize(self.stats_panel:GetWidth(),15);
	self.points_last_hour:SetPosition(0,120);
  self.points_last_hour:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_last_hour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.points_last_10min = Turbine.UI.Label();
  self.points_last_10min:SetParent(self.stats_panel);
  self.points_last_10min:SetSize(self.stats_panel:GetWidth(),15);
	self.points_last_10min:SetPosition(0,135);
  self.points_last_10min:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_last_10min:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.points_last_fight = Turbine.UI.Label();
  self.points_last_fight:SetParent(self.stats_panel);
  self.points_last_fight:SetSize(self.stats_panel:GetWidth(),15);
	self.points_last_fight:SetPosition(0,150);
  self.points_last_fight:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.points_last_fight:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  ---------- Frags -------------
  self.frags = Turbine.UI.Label();
  self.frags:SetParent(self.stats_panel);
  self.frags:SetSize(self.stats_panel:GetWidth(),20);
	self.frags:SetPosition(0,175);
  self.frags:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
  self.frags:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.frags:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.frags:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.frags:SetText(L.KillingBlows);
  
  self.frags_this_day = Turbine.UI.Label();
  self.frags_this_day:SetParent(self.stats_panel);
  self.frags_this_day:SetSize(self.stats_panel:GetWidth(),15);
	self.frags_this_day:SetPosition(0,195);
  self.frags_this_day:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.frags_this_day:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  self.frags_last_24h = Turbine.UI.Label();
  self.frags_last_24h:SetParent(self.stats_panel);
  self.frags_last_24h:SetSize(self.stats_panel:GetWidth(),15);
	self.frags_last_24h:SetPosition(0,210);
  self.frags_last_24h:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.frags_last_24h:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  self.frags_last_hour = Turbine.UI.Label();
  self.frags_last_hour:SetParent(self.stats_panel);
  self.frags_last_hour:SetSize(self.stats_panel:GetWidth(),15);
	self.frags_last_hour:SetPosition(0,225);
  self.frags_last_hour:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.frags_last_hour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.frags_last_10min = Turbine.UI.Label();
  self.frags_last_10min:SetParent(self.stats_panel);
  self.frags_last_10min:SetSize(self.stats_panel:GetWidth(),15);
	self.frags_last_10min:SetPosition(0,240);
  self.frags_last_10min:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.frags_last_10min:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.show_frags_button = Turbine.UI.Lotro.Button();
	self.show_frags_button:SetParent(self.stats_panel);
	self.show_frags_button:SetText(L.List);
  self.show_frags_button:SetWidth(90);
	self.show_frags_button:SetPosition(self.stats_panel:GetWidth()/2 - self.show_frags_button:GetWidth()/2,255);
  
  self.show_frags_button.Click = function()
    self.frag_panel:SetVisible(true);
    self.stats_panel:SetVisible(false);
	end
  
  ---------- Tracks -------------
  self.tracks = Turbine.UI.Label();
  self.tracks:SetParent(self.stats_panel);
  self.tracks:SetSize(self.stats_panel:GetWidth(),20);
	self.tracks:SetPosition(0,285);
  self.tracks:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
  self.tracks:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.tracks:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.tracks:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.tracks:SetText(L.Tracks);
  
  self.tracks_total = Turbine.UI.Label();
  self.tracks_total:SetParent(self.stats_panel);
  self.tracks_total:SetSize(self.stats_panel:GetWidth(),15);
	self.tracks_total:SetPosition(0,305);
  self.tracks_total:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.tracks_total:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.tracks_this_day = Turbine.UI.Label();
  self.tracks_this_day:SetParent(self.stats_panel);
  self.tracks_this_day:SetSize(self.stats_panel:GetWidth(),15);
	self.tracks_this_day:SetPosition(0,320);
  self.tracks_this_day:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.tracks_this_day:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  self.tracks_last_24h = Turbine.UI.Label();
  self.tracks_last_24h:SetParent(self.stats_panel);
  self.tracks_last_24h:SetSize(self.stats_panel:GetWidth(),15);
	self.tracks_last_24h:SetPosition(0,335);
  self.tracks_last_24h:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.tracks_last_24h:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  self.tracks_last_hour = Turbine.UI.Label();
  self.tracks_last_hour:SetParent(self.stats_panel);
  self.tracks_last_hour:SetSize(self.stats_panel:GetWidth(),15);
	self.tracks_last_hour:SetPosition(0,350);
  self.tracks_last_hour:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.tracks_last_hour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  
  self.tracks_last_10min = Turbine.UI.Label();
  self.tracks_last_10min:SetParent(self.stats_panel);
  self.tracks_last_10min:SetSize(self.stats_panel:GetWidth(),15);
	self.tracks_last_10min:SetPosition(0,365);
  self.tracks_last_10min:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.tracks_last_10min:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

  ---------- Frag Panel -------------
  
  self.frag_panel = Turbine.UI.Label();
  self.frag_panel:SetParent(self);
  self.frag_panel:SetSize(self:GetWidth() - 50,self:GetHeight() - 60);
  self.frag_panel:SetPosition(self:GetWidth() / 2 - self.frag_panel:GetWidth() / 2,40);
  self.frag_panel:SetVisible(false);
  
  self.frag_list = Turbine.UI.ListBox();
  self.frag_list:SetParent(self.frag_panel);
  self.frag_list:SetSize(self.frag_panel:GetWidth()-12,self.frag_panel:GetHeight() - 50);
  self.frag_list:SetPosition(0,25);
  self.frag_list:SetVisible(true);

  self.scrollbar = Turbine.UI.Lotro.ScrollBar();
  self.scrollbar:SetParent(self.frag_panel);
  self.scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical);
  self.scrollbar:SetSize(12,self.frag_list:GetHeight());
  self.scrollbar:SetPosition(self.frag_list:GetLeft() + self.frag_list:GetWidth(),self.frag_list:GetTop());
  self.scrollbar:SetZOrder(2);
  self.frag_list:SetVerticalScrollBar(self.scrollbar);
  
  self.name_label = Turbine.UI.Label();
	self.name_label:SetParent(self.frag_panel);
  self.name_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
  self.name_label:SetSize(self.frag_list:GetWidth()*2/3, 20);
  self.name_label:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.name_label:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.name_label:SetText(L.Name);
  
  self.name_label.MouseDown = function()
    if current_sortmode == alphabetical_desc then
      self:UpdateFragList(alphabetical_asc);
    else
      self:UpdateFragList(alphabetical_desc);
    end
	end
  
  self.frags_label = Turbine.UI.Label();
	self.frags_label:SetParent(self.frag_panel);
  self.frags_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
  self.frags_label:SetSize(self.frag_list:GetWidth()/3, 20);
  self.frags_label:SetPosition(self.name_label:GetWidth(),0);
  self.frags_label:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.frags_label:SetFontStyle(Turbine.UI.FontStyle.Outline);
  self.frags_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.frags_label:SetText(L.AmountFrags);
  
  self.frags_label.MouseDown = function()
    if current_sortmode == kills_desc then
      self:UpdateFragList(kills_asc);
    else
      self:UpdateFragList(kills_desc);
    end
	end
  
  self.show_stats_button = Turbine.UI.Lotro.Button();
	self.show_stats_button:SetParent(self.frag_panel);
	self.show_stats_button:SetText(L.Back);
  self.show_stats_button:SetWidth(150);
	self.show_stats_button:SetPosition(
    self.frag_panel:GetWidth()/2 - self.show_stats_button:GetWidth()/2,
    self.frag_panel:GetHeight() - self.show_stats_button:GetHeight()
  );
  
  self.show_stats_button.Click = function()
    self.frag_panel:SetVisible(false);
    self.stats_panel:SetVisible(true);
	end
  
  self.KeyDown = function(sender,args) 
    if (args.Action == Turbine.UI.Lotro.Action.Escape) then
      self:SetVisible(false);
    end
  end
  
end

function StatsWindow:Update()

  local flag = true;
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			self.rank:SetText(L.Strings_Rank..i);
      flag = false;
			break;
		end
	end
  if flag then self.rank:SetText(L.Strings_Rank.."15") end

  self.points_total:SetText(L.Stats_Total .. FormatPoints(data.numbers.points_total));
  self.commendations:SetText(L.Commendations .. FormatPoints(current_commendations));
	self.points_to_rankup:SetText(L.Stats_To_RankUp .. FormatPoints(GetRemainingPoints()));
  self.points_this_day:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.points_current_day));
  self.points_last_24h:SetText(L.Stats_Last_24h .. FormatPoints(GetPointsLast24h()));
	self.points_last_hour:SetText(L.Stats_Last_Hour .. FormatPoints(GetPointsLastHour()));
	self.points_last_10min:SetText(L.Stats_Last_10min .. FormatPoints(GetPointsLast10min()));
	self.points_last_fight:SetText(L.Stats_Last_Fight .. FormatPoints(points_last_fight));
  
	self.frags_this_day:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.frags_current_day));
  self.frags_last_24h:SetText(L.Stats_Last_24h .. FormatPoints(GetFragsLast24h()));
  self.frags_last_hour:SetText(L.Stats_Last_Hour .. FormatPoints(GetFragsLastHour()));
  self.frags_last_10min:SetText(L.Stats_Last_10min .. FormatPoints(GetFragsLast10min()));
  
  self.tracks_total:SetText(L.Stats_Total .. FormatPoints(data.numbers.tracks_total));
  self.tracks_this_day:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.tracks_current_day));
  self.tracks_last_24h:SetText(L.Stats_Last_24h .. FormatPoints(GetTracksLast24h()));
  self.tracks_last_hour:SetText(L.Stats_Last_Hour .. FormatPoints(GetTracksLastHour()));
  self.tracks_last_10min:SetText(L.Stats_Last_10min .. FormatPoints(GetTracksLast10min()));
  

end

function StatsWindow:UpdateFragList(sortmode)

  current_sortmode = sortmode;
  local sort_table = {};
  local i = 1;
  for name,frags in pairs(data.numbers.frags) do
    sort_table[i] = { name, frags };
    i = i + 1;
  end
  
  self.frag_list:ClearItems();
  if sortmode == alphabetical_desc then
    table.sort(sort_table, function(w1,w2) return w1[1] < w2[1] end);
  elseif sortmode == kills_desc then
    table.sort(sort_table, function(w1,w2) return w1[2] > w2[2] end);
  elseif sortmode == alphabetical_asc then
    table.sort(sort_table, function(w1,w2) return w1[1] > w2[1] end);
  elseif sortmode == kills_asc then
    table.sort(sort_table, function(w1,w2) return w1[2] < w2[2] end);
  end
  
  for i,j in pairs(sort_table) do
    local listItem = Turbine.UI.Control();
    listItem:SetSize(self.frag_list:GetWidth(), 14);

    local listName = Turbine.UI.Label();
    local listKills = Turbine.UI.Label();
    listName:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    listKills:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    listName:SetSize(self.frag_list:GetWidth()*3/4, listItem:GetHeight());
    listKills:SetSize(self.frag_list:GetWidth()/4, listItem:GetHeight());
    listName:SetParent(listItem);
    listKills:SetParent(listItem);
    listKills:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
    listName:SetText(j[1]);
    listKills:SetText(j[2]);
    listKills:SetPosition(listName:GetWidth(), 0);
    self.frag_list:AddItem(listItem);

    local separator = Turbine.UI.Label();
    separator:SetSize(listItem:GetWidth(), 1);
    separator:SetBackColor(Turbine.UI.Color(30/255,30/255,30/255));
    self.frag_list:AddItem(separator);

	end
  if not self.frag_list:GetItemCount() == 0 then
    self.frag_list:RemoveItemAt(self.frag_list:GetItemCount() * 2);
  end
end

